%READSDML Reads data in StatDataML-format.
%
% [A {B}] = READSDML(FILENAME,
% {NA.STRING,
% 'no.validate',
% 'categorical.as.int',
% 'list.as.structure',
% 'list.as.structarray'})
%
% A will be assigned the resulting data
% B (optional) will contain the Header-information as a structure.
%
% If 'no.validate' is supplied, no validation with the indicated .dtd-
% file is performed (default: file is validated before parsing)
%
% If 'nominal.as.int' is supplied, nominal information (factors) are
% read in as integers (the factor codes) instead of strings (the factor names).
%
% If 'list.as.structure' is supplied, lists with dimnames are
% coverted to a structure by folding the first dimension into the structure
% elements.
%
% If 'list.as.structarray' is supplied, lists with dimnames are
% converted to a struct array. This is most appropriate for data-frame like
% structures.
%
% NA.STRING may be supplied for substituting missing values.
% (default: value is set to NaN)
