%
% function sdml_array (x; mode:string; empty:bool)
%
% handles array-types (non-recursive)
%

function sdml_array (x,mode,empty)
global DROP_DIM
global TEXTDATA
global NAN
global POSINF
global NEGINF
global SEP
global NULL
global TRUE
global FALSE
global fh
global ASSTRING
global STR

sdml_p('<array>')

% dimension-section
sdml_po('<dimension>')
if ~isempty(x) sdml_p(''); end;
l=size(x);

% for strings, set length to 1
if isstr(x) & length(size(x))==2 & size(x,1)==1; l=1; end

for i=1:length(l)
  if ~DROP_DIM | l(i)>1 % drop singletons
    sdml_po('<dim size="');
    sdml_po(num2str(l(i)));
    sdml_p('"></dim>')
  end
end
% create at least 1 dimension
if DROP_DIM & prod(l)==1 sdml_p('<dim size="1"></dim>'); end
sdml_p('</dimension>')

% type-section

sdml_p('<type>')

if (strcmp(mode,'integer') | strcmp(mode,'real') | strcmp(mode,'complex'))
  sdml_p('<numeric>')
  if (strcmp(mode,'complex'))
    sdml_p('<complex/>')
  else
    sdml_p(strcat('<',mode,'>'))
    sdml_p(strcat('<min>', num2str(min(x( : ))), '</min>'))
    sdml_p(strcat('<max>', num2str(max(x( : ))), '</max>'))
    sdml_p(strcat('</',mode,'>'))
  end;
  sdml_p('</numeric>')
else
  sdml_p(strcat('<',mode,'/>'))
end;

sdml_p('</type>')

% data-section


%compute row and column from index



% -header
if TEXTDATA
  sdml_po(strcat('<textdata sep="',SEP,'"'))
  if strcmp (mode, 'character') po (strcat(' null.string="',NULL,'"')); end;
  if (strcmp(mode,'integer') | strcmp(mode,'real') | strcmp(mode,'complex'))
    po (strcat(' posinf.string="',POSINF,'"'))
    po (strcat(' neginf.string="',NEGINF,'"'))
    po (strcat(' nan.string="',NAN,'"'))
  end
  if strcmp(mode,'logical')
    po (strcat(' true="',TRUE,'"'))
    po (strcat(' false="',FALSE,'"'))
  end
else
  sdml_po('<data')
end
if isempty(x)
        sdml_po('>')
else
        sdml_p('>')
end;
% -data
if ~empty
  c = 0;
  len = prod(size(x));
  for i=1:len % for all array-items
      if strcmp(mode,'logical') % logical
        if ~TEXTDATA
          if (x(i-floor((i-1)/l(1))*l(1),floor((i-1)/l(1))+1)) sdml_po('<T/> '); else sdml_po('<F/> '); end
        else
          if (x(i-floor((i-1)/l(1))*l(1),floor((i-1)/l(1))+1)) sdml_po(strcat(TRUE, SEP(1))); else sdml_po(strcat(FALSE, SEP(1))); end
        end
      elseif strcmp(mode,'character') % string/char array ?



        if ~(length(size(x))==2 & size(x,1)==1) % char array ?

          sdml_tag (sdml_subst(x(i-floor((i-1)/l(1))*l(1),floor((i-1)/l(1))+1)));




        else % no -> string !



          sdml_tag (sdml_subst(x))
          break

        end
      else % no -> numeric !
        if strcmp(mode,'complex')
          re=real(x(i-floor((i-1)/l(1))*l(1),floor((i-1)/l(1))+1));
          co=imag(x(i-floor((i-1)/l(1))*l(1),floor((i-1)/l(1))+1));
          if co<0 si='-'; else si='+'; end
          if isnan (x(i-floor((i-1)/l(1))*l(1),floor((i-1)/l(1))+1))
            res = NAN;
            cos = NAN;
          else
                if re==inf res = POSINF;
            elseif re==-inf res = NEGINF;
            else res = num2str(re);
            end
                if co==inf cos = POSINF;
            elseif co==-inf cos = NEGINF;
            else cos = num2str(co);
            end
          end

          if ~TEXTDATA
            if ASSTRING
               STR = strcat(STR, sprintf('<ce><r>%s</r><i>%s</i></ce>',res,cos));
            else
              fprintf (fh, '<ce><r>%s</r><i>%s</i></ce>',res,cos);
            end;
          else
            sdml_tag (strcat(res, ...
                             si(1), ...
                             cos, ...
                             'i'))
          end
        else
          sdml_numtag (x(i-floor((i-1)/l(1))*l(1),floor((i-1)/l(1))+1))
        end
      end

      % line break after 5/10 items
      c=c+1;
      if c > (4+TEXTDATA*5) & i < len
        sdml_p ('')
        c=0;
      end
    end

    sdml_p('')
  end

  if ~TEXTDATA
    sdml_p('</data>')
  else
    sdml_p('</textdata>')
  end

  sdml_p('</array>')
